#!/usr/bin/env python
# -*- Python -*-

from PyQt4 import QtCore, QtGui

import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM_aist
import RTC

import codecs




tPoint = []
PortNum = []


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
QtGraph_spec = ["implementation_id", "QtGraph", 
		 "type_name",         "QtGraph", 
		 "description",       "QtGraph Component", 
		 "version",           "0.1", 
		 "vendor",            "Miyamoto Nobuhiko", 
		 "category",          "TEST", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

class QtGraph(OpenRTM_aist.DataFlowComponentBase):
	def __init__(self, manager):
                
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self.Port = []
		self.PortOut = []
		self.EXENUM = []

		for i in range(0, len(PortNum)):
                    self.EXENUM.append(0)
                    if PortNum[i] == 0:

                        self.Port.append(RTC.TimedLong(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("Long%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("Long%d"%i,self.PortOut[i])

                    if PortNum[i] == 1:

                        self.Port.append(RTC.TimedLongSeq(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("LongSeq%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("LongSeq%d"%i,self.PortOut[i])

                    if PortNum[i] == 2:

                        self.Port.append(RTC.TimedDouble(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("Double%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("Double%d"%i,self.PortOut[i])

                    if PortNum[i] == 3:

                        self.Port.append(RTC.TimedDoubleSeq(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("DoubleSeq%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("DoubleSeq%d"%i,self.PortOut[i])

                    if PortNum[i] == 4:

                        self.Port.append(RTC.TimedFloat(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("Float%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("Float%d"%i,self.PortOut[i])

                    if PortNum[i] == 5:

                        self.Port.append(RTC.TimedFloatSeq(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("FloatSeq%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("FloatSeq%d"%i,self.PortOut[i])

                    if PortNum[i] == 6:

                        self.Port.append(RTC.TimedBoolean(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("Boolean%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("Boolean%d"%i,self.PortOut[i])

                    if PortNum[i] == 7:

                        self.Port.append(RTC.TimedBooleanSeq(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("BooleanSeq%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("BooleanSeq%d"%i,self.PortOut[i])

                    if PortNum[i] == 8:

                        self.Port.append(RTC.TimedShort(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("Short%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("Short%d"%i,self.PortOut[i])


                    if PortNum[i] == 9:

                        self.Port.append(RTC.TimedShortSeq(RTC.Time(0,0),[]))
                        self.PortOut.append(OpenRTM_aist.InPort("ShortSeq%d"%i, self.Port[i], OpenRTM_aist.RingBuffer(8)))
                        self.registerInPort("ShortSeq%d"%i,self.PortOut[i])
            
		# Set OutPort buffers

		
		





		

		

		

		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		

		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	def onInitialize(self):
            
		# Bind variables and configuration variable
		
		return RTC.RTC_OK


	
	#def onFinalize(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OKvdef onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onActivated(self, ec_id):
	#
        #       return RTC.RTC_OK
	
	#def onDeactivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onExecute(self, ec_id):

            for i in range(0, len(PortNum)):
                if self.PortOut[i].isNew():
                    inport = self.PortOut[i].read()
                    if PortNum[i] == 1 or PortNum[i] == 3 or PortNum[i] == 5 or PortNum[i] == 7 or PortNum[i] == 9:
                        for j in range(0, len(inport.data)):
                            if j >= len(tPoint[i]):
                                tPoint[i].append([])
                            tPoint[i][j].append([])
                            tPoint[i][j][self.EXENUM[i]].append(self.EXENUM[i])
                            if PortNum[i] != 7:
                                tPoint[i][j][self.EXENUM[i]].append(inport.data[j])
                            else:
                                if inport.data[j] == True:
                                    tPoint[i][j][self.EXENUM[i]].append(1)
                                else:
                                    tPoint[i][j][self.EXENUM[i]].append(0)
                    
                    else:
                            if 1 > len(tPoint[i]):
                                tPoint[i].append([])
                            tPoint[i][0].append([])
                            tPoint[i][0][self.EXENUM[i]].append(self.EXENUM[i])
                            if PortNum[i] != 6:
                                tPoint[i][0][self.EXENUM[i]].append(inport.data)
                            else:
                                if inport.data == True:
                                    tPoint[i][0][self.EXENUM[i]].append(1)
                                else:
                                    tPoint[i][0][self.EXENUM[i]].append(0)

                    
                    self.EXENUM[i] += 1


            
            
            
	    return RTC.RTC_OK
	
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK



class lineGraphWidget(QtGui.QWidget):
    def __init__(self, parent=None):
        super(lineGraphWidget, self).__init__(parent)

        self.floatBased = False
        self.antialiased = False
        self.frameNo = 0

        self.setBackgroundRole(QtGui.QPalette.Base)
        self.setSizePolicy(QtGui.QSizePolicy.Expanding,
                QtGui.QSizePolicy.Expanding)

        self.tPoint = []
        self.frameNo = 0

        self.xnum = 10
        self.xnum2 = 0
        self.ynum = 10.0
        self.ynum2 = -1.0

        self.xrange = 10

        self.setMinimumSize(200, 200)

        self.yfix = False

        self.num = 0

        

    def SETNUM(self, NUM):
        self.num = NUM

    def setFloatBased(self, floatBased):
        self.floatBased = floatBased
        self.update()

    def setAntialiased(self, antialiased):
        self.antialiased = antialiased
        self.update()

    def minimumSizeHint(self):
        return QtCore.QSize(50, 50)

    def sizeHint(self):
        return QtCore.QSize(180, 180)

    def nextAnimationFrame(self):
        self.frameNo += 1
        self.update()
        
    def paintEvent(self, event):
        self.tPoint = tPoint[self.num]
        
        painter = QtGui.QPainter(self)



        painter.fillRect(event.rect(), QtGui.QBrush(QtCore.Qt.white))

        painter.setRenderHint(QtGui.QPainter.Antialiasing, self.antialiased)
        
        painter.setRenderHint(QtGui.QPainter.Antialiasing)

        painter.setPen(QtGui.QPen(QtCore.Qt.black, 0.6,
                QtCore.Qt.SolidLine, QtCore.Qt.RoundCap, QtCore.Qt.RoundJoin))

        if self.yfix == False:
            self.ynum = 0.001
            self.ynum2 = -0.001

        for j in range(0, len(self.tPoint)):
            if self.yfix == True:
                self.xnum2 = 0
                self.xnum = self.xrange
            if len(self.tPoint[j]) > 1:
                if self.yfix == False:
                    for i in range(0, len(self.tPoint[j])-1):
                        if(self.ynum < self.tPoint[j][i][1]):
                            self.ynum = self.tPoint[j][i][1]
                        if(self.ynum2 > self.tPoint[j][i][1]):
                            self.ynum2 = self.tPoint[j][i][1]
                    for i in range(0, len(self.tPoint[j])-1):
                        if self.xnum <  self.tPoint[j][i][0]:
                            self.xnum = self.tPoint[j][i][0]
                        if self.xnum - self.xnum2 > self.xrange:
                            self.xnum2 = self.xnum - self.xrange
            
        for j in range(0, len(self.tPoint)):
            if len(self.tPoint[j]) > 1:
                temp = self.ynum - self.ynum2
                transy = self.height()*8/10*self.ynum2/temp
                genten = self.height()*37/40+transy
                if self.xrange < len(self.tPoint[j]):
                    for i in range(self.xnum2, self.xnum2+self.xrange-1):
                        temp5 = self.tPoint[j][i][0] - self.xnum2
                        temp1 = self.width()*1/10 + self.width()*7/10*temp5/self.xrange
                        temp2 = genten - self.height()*7/10*self.tPoint[j][i][1]/temp
                        temp6 = self.tPoint[j][i+1][0] - self.xnum2
                        temp3 = self.width()*1/10 + self.width()*7/10*temp6/self.xrange
                        temp4 = genten - self.height()*7/10*self.tPoint[j][i+1][1]/temp
                        painter.drawLine(temp1, temp2, temp3, temp4)
                else:
                    for i in range(0, len(self.tPoint[j])-1):
                        temp5 = self.tPoint[j][i][0] - self.xnum2
                        temp1 = self.width()*1/10 + self.width()*7/10*temp5/self.xrange
                        temp2 = genten - self.height()*7/10*self.tPoint[j][i][1]/temp
                        temp6 = self.tPoint[j][i+1][0] - self.xnum2
                        temp3 = self.width()*1/10 + self.width()*7/10*temp6/self.xrange
                        temp4 = genten - self.height()*7/10*self.tPoint[j][i+1][1]/temp
                        painter.drawLine(temp1, temp2, temp3, temp4)


        
        temp = self.ynum - self.ynum2
        transy = self.height()*8/10*self.ynum2/temp

        painter.setPen(QtGui.QPen(QtCore.Qt.red, 0.5,
                QtCore.Qt.SolidLine, QtCore.Qt.RoundCap, QtCore.Qt.RoundJoin))
        

        painter.drawLine(self.width()*1/10, self.height()*1/10, self.width()*1/10, self.height()*9/10)
        painter.drawLine(self.width()*1/10, self.height()*1/10, self.width()*1/10 + self.width()*1/50, self.height()*1/10 + self.height()*1/20)
        painter.drawLine(self.width()*1/10, self.height()*1/10, self.width()*1/10 - self.width()*1/50, self.height()*1/10 + self.height()*1/20)

        painter.drawLine(self.width()*1/10, self.height()*9/10+transy, self.width()*9/10, self.height()*9/10+transy)
        painter.drawLine(self.width()*9/10, self.height()*9/10+transy, self.width()*9/10 - self.width()*1/20, self.height()*9/10 - self.height()*1/50+transy)
        painter.drawLine(self.width()*9/10, self.height()*9/10+transy, self.width()*9/10 - self.width()*1/20, self.height()*9/10 + self.height()*1/50+transy)
        

        painter.setPen(QtGui.QPen(QtCore.Qt.blue, 0.05,
                QtCore.Qt.SolidLine, QtCore.Qt.RoundCap, QtCore.Qt.RoundJoin))

        for i in range(2, 18):
            painter.drawLine(self.width()*1/20*i, self.height()*1/10, self.width()*1/20*i, self.height()*9/10)

        for i in range(0, 18):
            painter.drawLine(self.width()*1/10, self.height()*9/10-self.height()*1/20*i, self.width()*9/10, self.height()*9/10-self.height()*1/20*i)
            

        painter.setPen(QtGui.QPen(QtCore.Qt.black, 0.4,
                QtCore.Qt.SolidLine, QtCore.Qt.RoundCap, QtCore.Qt.RoundJoin))

        painter.drawLine(self.width()*5/40, self.height()*2/10, self.width()*3/40, self.height()*2/10)


        painter.drawText(self.width()*1/40,
                         self.height()*2/10, "%lf" % self.ynum)


        painter.drawLine(self.width()*5/40, self.height()*9/10, self.width()*3/40, self.height()*9/10)

        painter.drawText(self.width()*1/40,
                         self.height()*9/10, "%lf" % self.ynum2)

        
        painter.drawLine(self.width()*8/10, self.height()*35/40+transy, self.width()*8/10, self.height()*37/40+transy)

        painter.drawText(self.width()*8/10,
                         self.height()*39/40+transy, "%d" % self.xnum)

        painter.setPen(QtGui.QPen(QtCore.Qt.black, 0.6,
                QtCore.Qt.SolidLine, QtCore.Qt.RoundCap, QtCore.Qt.RoundJoin))

        painter.drawText(self.width()*1/10,
                         self.height()*39/40+transy, "%d" % self.xnum2)

    def SetRange(self, R):
        self.xrange = R

    def SetLowX(self, X):
        self.ynum2 = X

    def SetHighX(self, X):
        self.ynum = X

    def SetFix(self, X):
        self.yfix = X


                

class Dialog(QtGui.QDialog):
    def __init__(self, parent=None):
        super(Dialog, self).__init__(parent)
        
        self.mainLayout = QtGui.QVBoxLayout()

        self.lineGraphWidget = lineGraphWidget()
        self.timer = QtCore.QTimer(self)
        self.timer.timeout.connect(self.lineGraphWidget.nextAnimationFrame)
        self.timer.start(50)
        self.mainLayout.addWidget(self.lineGraphWidget)


        self.typeLayout = QtGui.QHBoxLayout()

        typeLabel = QtGui.QLabel("Type")

        self.TypeBox = QtGui.QComboBox()

        self.typeLayout.addWidget(typeLabel)
        self.typeLayout.addWidget(self.TypeBox)

        self.TypeBox.addItem("TimedLong")
        self.TypeBox.addItem("TimedLongSeq")
        self.TypeBox.addItem("TimedDouble")
        self.TypeBox.addItem("TimedDoubleSeq")
        self.TypeBox.addItem("TimedFloat")
        self.TypeBox.addItem("TimedFloatSeq")
        self.TypeBox.addItem("TimedBoolean")
        self.TypeBox.addItem("TimedBooleanSeq")
        self.TypeBox.addItem("TimedShort")
        self.TypeBox.addItem("TimedShortSeq")


        

        Typewidget = QtGui.QWidget()
        
        Typewidget.setLayout(self.typeLayout)

        Typewidget.setMinimumSize(10, 10)

        self.mainLayout.addWidget(Typewidget)



        self.rangeLayout = QtGui.QHBoxLayout()

        rangeLabel = QtGui.QLabel("Range")
        
        self.RANGEBOX = QtGui.QDoubleSpinBox()

        self.RANGEBOX.setMinimum(0)
        self.RANGEBOX.setMaximum(100)

        self.RANGEBOX.valueChanged.connect(self.changeR)

        self.rangeLayout.addWidget(rangeLabel)
        self.rangeLayout.addWidget(self.RANGEBOX)

        RANGEwidget = QtGui.QWidget()
        
        RANGEwidget.setLayout(self.rangeLayout)

        RANGEwidget.setMinimumSize(10, 10)

        self.mainLayout.addWidget(RANGEwidget)



        self.HIGHLayout = QtGui.QHBoxLayout()

        HIGHLabel = QtGui.QLabel("HIGH")
        
        self.HIGHBOX = QtGui.QDoubleSpinBox()

        self.HIGHBOX.setMinimum(-100)
        self.HIGHBOX.setMaximum(100)

        self.HIGHBOX.valueChanged.connect(self.changeHigh)

        self.HIGHLayout.addWidget(HIGHLabel)
        self.HIGHLayout.addWidget(self.HIGHBOX)

        HIGHwidget = QtGui.QWidget()
        
        HIGHwidget.setLayout(self.HIGHLayout)

        HIGHwidget.setMinimumSize(10, 10)

        self.mainLayout.addWidget(HIGHwidget)



        self.LOWLayout = QtGui.QHBoxLayout()

        LOWLabel = QtGui.QLabel("LOW")
        
        self.LOWBOX = QtGui.QDoubleSpinBox()

        self.LOWBOX.setMinimum(-100)
        self.LOWBOX.setMaximum(100)

        self.LOWBOX.valueChanged.connect(self.changeLow)

        self.LOWLayout.addWidget(LOWLabel)
        self.LOWLayout.addWidget(self.LOWBOX)

        LOWwidget = QtGui.QWidget()
        
        LOWwidget.setLayout(self.LOWLayout)

        LOWwidget.setMinimumSize(10, 10)

        self.mainLayout.addWidget(LOWwidget)


        self.FIXLayout = QtGui.QHBoxLayout()

        FIXLabel = QtGui.QLabel("FIX")

        self.FIXBox = QtGui.QComboBox()

        self.FIXLayout.addWidget(FIXLabel)
        self.FIXLayout.addWidget(self.FIXBox)

        self.FIXBox.addItem("Free")
        self.FIXBox.addItem("Fix")

        self.FIXBox.currentIndexChanged.connect(self.changeFix)

        

        FIXwidget = QtGui.QWidget()
        
        FIXwidget.setLayout(self.FIXLayout)

        FIXwidget.setMinimumSize(10, 10)

        self.mainLayout.addWidget(FIXwidget)

        
        

        

        self.setLayout(self.mainLayout)

        self.setMinimumSize(200, 450)

    def SETNUM(self, NUM):
        self.lineGraphWidget.SETNUM(NUM)

    def changeR(self):
         self.lineGraphWidget.SetRange(self.RANGEBOX.value())

    def changeLow(self):
        self.lineGraphWidget.SetLowX(self.LOWBOX.value())

    def changeHigh(self):
        self.lineGraphWidget.SetHighX(self.HIGHBOX.value())

    def changeFix(self):
        if self.FIXBox.currentText() == "Free":
            self.lineGraphWidget.SetFix(False)
        elif self.FIXBox.currentText() == "Fix":
            self.lineGraphWidget.SetFix(True)

    def RETYPE(self):
        return self.TypeBox.currentText()


        
        
        


class MainWindow(QtGui.QMainWindow):
    def __init__(self):
        super(MainWindow, self).__init__()

        self.currentPath = ''



        fileMenu = QtGui.QMenu("&File", self)
        openAction = fileMenu.addAction("&Open...")
        openAction.setShortcut("Ctrl+O")
        quitAction = fileMenu.addAction("E&xit")
        quitAction.setShortcut("Ctrl+Q")

        self.menuBar().addMenu(fileMenu)




        quitAction.triggered.connect(QtGui.qApp.quit)

        self.layout = QtGui.QGridLayout()


        

        self.lineGraphWidget = []

        self.GraphWidget = QtGui.QWidget()

        self.GraphLayout = QtGui.QGridLayout()

        self.GraphWidget.setLayout(self.GraphLayout)

        self.GNUM = 0

        

        self.NUMBOX = QtGui.QSpinBox()

        self.NUMBOX.setMinimum(0)
        self.NUMBOX.setMaximum(100)


        self.NUMBOX.valueChanged.connect(self.Create)

        self.layout.addWidget(self.NUMBOX)



        self.button1 = QtGui.QPushButton("Create")
        self.layout.addWidget(self.button1)
        self.button1.clicked.connect(self.CreateRTC)



        NameComboBox = QtGui.QComboBox()

	NameComboBox.setEditable(True)

        self.layout.addWidget(NameComboBox)



        self.widget = QtGui.QWidget()

        self.layout.addWidget(self.GraphWidget)
        
        self.widget.setLayout(self.layout)

        self.setCentralWidget(self.widget)

        self.setWindowTitle("QtGraph Component")

        self.RTCNUM = 0

    def CreateRTC(self):
        if self.RTCNUM > 0:
            flag = True
            while(flag):
                tPoint.remove(tPoint[0])
                if len(tPoint) == 0:
                    flag = False
            for i in range(0,len(self.lineGraphWidget)):
                tPoint.append([])
            flag = True
            while(flag):
                PortNum.remove(PortNum[0])
                if len(PortNum) == 0:
                    flag = False
        
            

        self.RTCNUM += 1
        
        
        
        for i in range(0, len(self.lineGraphWidget)):
            if self.lineGraphWidget[i].RETYPE() == "TimedLong":
                PortNum.append(0)
            if self.lineGraphWidget[i].RETYPE() == "TimedLongSeq":
                PortNum.append(1)
            if self.lineGraphWidget[i].RETYPE() == "TimedDouble":
                PortNum.append(2)
            if self.lineGraphWidget[i].RETYPE() == "TimedDoubleSeq":
                PortNum.append(3)
            if self.lineGraphWidget[i].RETYPE() == "TimedFloat":
                PortNum.append(4)
            if self.lineGraphWidget[i].RETYPE() == "TimedFloatSeq":
                PortNum.append(5)
            if self.lineGraphWidget[i].RETYPE() == "TimedBoolean":
                PortNum.append(6)
            if self.lineGraphWidget[i].RETYPE() == "TimedBooleanSeq":
                PortNum.append(7)
            if self.lineGraphWidget[i].RETYPE() == "TimedShort":
                PortNum.append(8)
            if self.lineGraphWidget[i].RETYPE() == "TimedShortSeq":
                PortNum.append(9)
        
	mgr = OpenRTM_aist.Manager.init(len(sys.argv), sys.argv)
	mgr.activateManager()
	
	profile = OpenRTM_aist.Properties(defaults_str=QtGraph_spec)
        mgr.registerFactory(profile,
                            QtGraph,
                            OpenRTM_aist.Delete)

        # Create a component
        comp = mgr.createComponent("QtGraph")
        
	mgr.runManager(True)


    def Create(self):

        if self.GNUM < self.NUMBOX.value():
        
            for i in range(self.GNUM, self.NUMBOX.value()):
                self.lineGraphWidget.append(Dialog())
                tPoint.append([])
                self.lineGraphWidget[i].SETNUM(i)
                self.GraphLayout.addWidget(self.lineGraphWidget[i], 0, i)

        elif self.GNUM > self.NUMBOX.value():
            for i in range(self.NUMBOX.value(), self.GNUM):
                tPoint.remove(tPoint[i])
                self.GraphLayout.removeWidget(self.lineGraphWidget[i])
                self.lineGraphWidget.remove(self.lineGraphWidget[i])
        
                self.GraphWidget.close()
                self.GraphWidget = QtGui.QWidget()
                self.GraphLayout = QtGui.QGridLayout()
                self.GraphWidget.setLayout(self.GraphLayout)
                self.layout.addWidget(self.GraphWidget)

            for i in range(0, self.NUMBOX.value()):
                self.GraphLayout.addWidget(self.lineGraphWidget[i], 0, i)
                
        self.GNUM = len(self.lineGraphWidget)
            
        

        
        

if __name__ == '__main__':

    import sys

    app = QtGui.QApplication(sys.argv)

    window = MainWindow()
    
    window.show()
    sys.exit(app.exec_())


